/*
 *	clipmath.h
 *
 *	Œ菬Cu`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Sat Dec  1 07:12:31 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_MATH_H__
#define __CLIP_MATH_H__

/*****************************************************************************
 *	萔
 *****************************************************************************/

#define PI	3.14159265358979323846F	/*  */
#define PI2	(PI * 2)		/* 2 */
#define PI_2	(PI / 2)		/* /2 */

/*****************************************************************************
 *	xNg
 *****************************************************************************/

/* xNg\܂B
 */
typedef struct _VECTOR {
	float x;	/* X */
	float y;	/* Y */
	float z;	/* Z */
} VECTOR;

/* `ς݂̃xNgłB
 */
extern const VECTOR VECTOR_0;	/* [xNg */
extern const VECTOR VECTOR_X;	/* XPʃxNg */
extern const VECTOR VECTOR_Y;	/* YPʃxNg */
extern const VECTOR VECTOR_Z;	/* ZPʃxNg */

/* xNg쐬܂B
 * [in]
 *	o		ʂi[xNgB
 *	x,y,z		X,Y,Z̒lB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_init(VECTOR* o, float x, float y, float z);

/* xNg̊e𕄍]܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		]xNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_neg(VECTOR* o, const VECTOR* a);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_add(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_sub(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_mul(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_div(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊e𓯂lŏZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		ZxNgB
 *	b		ZlB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_mul1(VECTOR* o, const VECTOR* a, float b);

/* xNg̊e𓯂lŏZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		ZxNgB
 *	b		ZlB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_div1(VECTOR* o, const VECTOR* a, float b);

/* xNg̓(dot product)߂܂B
 * [in]
 *	a,b		ς߂xNgB
 * [out]
 *	߂l		ς̒lB
 * [note]
 * 	* ς̒`: aEb = |a||b|cos
 */
float vector_dot(const VECTOR* a, const VECTOR* b);

/* xNg̊O(cross product)߂܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		Oς߂xNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 * 	* Oς̒`: a~b = |a||b|sin*c
 * 	  AcabɐȒPʃxNgƂB
 */
VECTOR* vector_cross(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg𐳋K(normalize)܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		KxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_normal(VECTOR* o, const VECTOR* a);

/* xNg̒(magnitude)߂܂B
 * [in]
 *	a		߂xNgB
 * [out]
 * 	߂l		ʂ̒lB
 */
float vector_mag(const VECTOR* a);

/* xNg̒̓(square magnitude)߂܂B
 * [in]
 *	a		̓߂xNgB
 * [out]
 * 	߂l		ʂ̒lB
 */
float vector_mag2(const VECTOR* a);

/* ˃xNg߂܂B
 * [in]
 *	o		ʂi[xNgB
 *	N		˖ʂ̖@xNgB
 *	E		˓_ւ̃xNgB
 *			ƁAťxNgłB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* ˃xNǧ́A̒ʂłB
 *		R = 2(EEN)N - E
 *	  l:
 *	  xNgE,N_ƂāAEN֐낵ꍇA
 *	  ̐NƌP_
 *		P = (EEN)N
 *	  łBȂȂA(EEN)̓xNgE,N̂ȂpcoslłB
 *	  ŔAPEɓ_Ώ̂ȈʒuAȂ킿A
 *	  EAE->P̓{i񂾈ʒułB
 *		R = E + 2(P - E)
 *		  = 2P - E
 *		  = 2(EEN)N - E
 *	  ȏłB
 *	* xNgE,ŃAKĂȂ΂܂B
 *	  KĂȂꍇAԈʂƂȂ܂B
 *	  ۂɂ́AEKĂȂꍇ́A
 *	    PɌʂ̃xNg̑傫EɓȂ邾̂悤Ɏv܂B
 *	    (mF)
 *	* xNgÉA"t"xNgł邱ƂɒӂĂB
 *	  ̊֐́A˃xNg߂ƌA
 *	  NƂāAEɐΏ̂ȃxNg߂AƌmłB
 *	  ExNgƓɎg₷Ǝv̂łA
 *	  Ƃċt̕ʓIȂ悤Ȃ̂ŁAȂĂ݂܂B
 */
VECTOR* vector_reflect(VECTOR* o, const VECTOR* N, const VECTOR* E);

/*****************************************************************************
 *	s
 *****************************************************************************/

/* s\܂B
 */
typedef struct _MATRIX {
	float a00, a01, a02;	/* pxNgX */
	float a10, a11, a12;	/* pxNgY */
	float a20, a21, a22;	/* pxNgZ */
	float a30, a31, a32;	/* sړ */
} MATRIX;

/* `ς݂̍słB
 */
extern const MATRIX MATRIX_I;	/* P(identity)s */

/* s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	a00,a01,a02	pxNgXB
 *	a10,a11,a12	pxNgYB
 *	a20,a21,a22	pxNgZB
 *	a30,a31,a32	sړ
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_init(MATRIX* o,
	float a00, float a01, float a02,
	float a10, float a11, float a12,
	float a20, float a21, float a22,
	float a30, float a31, float a32);
 
/* ]u(transpose)s߂܂B
 * [in]
 *	o		ʂi[sB
 *	a		]usB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* sړ͏A(0,0,0)ƂȂ܂B
 */
MATRIX* matrix_xpose(MATRIX* o, const MATRIX* a);

/* ts(inverse)߂܂B
 * [in]
 *	o		ʂi[sB
 *	a		ts߂sB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* stȍsw肵ꍇ̌ʂ́A`łB
 */
MATRIX* matrix_inv(MATRIX* o, const MATRIX* a);

/* K(normalized orthogonal)s̋ts߂܂B
 * [in]
 *	o		ʂi[sB
 *	a		ts߂sB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* matrix_inv()AłB
 *	* KłȂsw肵ꍇ̌ʂ́A`łB
 */
MATRIX* matrix_invno(MATRIX* o, const MATRIX* a);

/* xNgϊ(transform)܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		ϊxNgB
 *	b		ϊsB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_xform(VECTOR* o, const VECTOR* a, const MATRIX* b);

/* sϊ(transform)܂B
 * [in]
 *	o		ʂi[sB
 *	a		ϊsB
 *	b		ϊsB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_xform(MATRIX* o, const MATRIX* a, const MATRIX* b);

/*  sړ(translate)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	x,y,z		X,Y,Z̕sړB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_xlate(MATRIX* o, float x, float y, float z);

/* gEk(scale)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	x,y,z		X,Y,Z̊gEkWB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_scale(MATRIX* o, float x, float y, float z);

/* X,Y,ZƂWŁAgEks쐬܂B
 * [in]
 *	o		ʂi[sB
 *	a		gEkWB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_scale1(MATRIX* o, float a);

/* Cӎ](rotate)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	x,y,z		]̃xNgB
 *	a		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* ]̃xNǵAKĂȂĂ\܂B
 */
MATRIX* matrix_rot(MATRIX* o, float x, float y, float z, float a);

/* Œꎲ](rotate)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	a		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_rotx(MATRIX* o, float a);
MATRIX* matrix_roty(MATRIX* o, float a);
MATRIX* matrix_rotz(MATRIX* o, float a);

/* Œ񎲉](rotate)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	a,b,c		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_rotxyx(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotxzx(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotyxy(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotyzy(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotzxz(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotzyz(MATRIX* o, float a, float b, float c);

/* ŒO](rotate)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	a,b,c		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_rotxyz(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotxzy(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotyxz(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotyzx(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotzxy(MATRIX* o, float a, float b, float c);
MATRIX* matrix_rotzyx(MATRIX* o, float a, float b, float c);

/* ]̃xNgƁA]px߂܂B
 * [in]
 *	v		]̃xNgi[xNgB
 *	a		ׂsB
 * [out]
 *	߂l		]pxB
 */
float matrix_rotget(VECTOR* o, const MATRIX* a);

/* p(orientate)s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	dx,dy,dz	Z̎pxNgB
 *	ux,uy,uz	Y̎pxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* pxNǵAKĂȂĂ\܂B
 */
MATRIX* matrix_orient(MATRIX* o,
	float dx, float dy, float dz,
	float ux, float uy, float uz);

/* _ϊs쐬܂B
 * [in]
 *	o		ʂi[sB
 *	ex,ey,ez	_WB
 *	cx,cy,cz	_WB
 *	bank		oNpxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_lookat(MATRIX* o,
	float ex, float ey, float ez,
	float cx, float cy, float cz,
	float bank);

/* s(frustum)쐬܂B
 * [in]
 *	o		ʂi[sB
 *	width		eʂ̕              (Wn)
 *	height		eʂ̍            (Wn)
 *	front		tgNbsO(Wn)
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* Sȓϊł͂ȂAZW͎Ŵ܂ܕω܂B
 *	  ȂȂÃCuł͍s3x4ŕ\Ă̂ŁA
 *	  ZW̐Klϊs\ȂłB
 *	  Azobt@ł͂ȂAz\[gz肵Ă̂ŁA
 *	  p͂ȂƎv܂B
 *	* ̍sōWϊł́AX,YW͐K܂B
 *	  x=x/z,y=y/z sāAx,y(-1,1)ɓeKv܂B
 */
MATRIX* matrix_frustum(MATRIX* o, float width, float height, float front);

/* s(perspective)쐬܂B
 * [in]
 *	o		ʂi[sB
 *	fovy		pxB
 *	aspect		AXyNg()
 *	front		tgNbsO(Wn)
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* matrix_frustum()̃RgQƂĂB
 */
MATRIX* matrix_perspect(MATRIX* o, float fovy, float aspect, float front);

/* r[|[gϊs(viewport)܂B
 * [in]
 *	o		ʂi[sB
 *	left,top	r[|[g_W(XN[Wn)
 *	width,height	r[|[gTCY  (XN[Wn)
 *			^͌Œ菬ł͂Ȃł邱Ƃ
 *			  ӂĂB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* ϊ -> x=x/z,y=y/z -> r[|[gϊ
 *	  ̏œKpꍇ́Amatrix_viewport()gĂB
 *	* ϊ -> r[|[gϊ -> x=x/z,y=y/z
 *	  ̏œKpꍇ́Amatrix_viewportz()gĂB
 *	* matrix_viewport()gWϊ̎菇́ÂƂłB
 *		1. T = fϊ * _ϊ * ϊ ɂWϊ
 *		2. ZNbsO
 *		3. x = x / z, y = y / z
 *		4. T = r[|[gϊ ɂWϊ
 *		5. XYNbsO
 *	* ɑ΂Amatrix_viewportz()gꍇ́A
 *		1. T = fϊ * _ϊ * ϊ * r[|[gϊ
 *	  	   ɂAWϊ
 *		2. ZNbsO
 *		3. x = x / z, y = y / z
 *		4. XYNbsO
 *	  ƂȂA菇炷Ƃł܂B
 */
MATRIX* matrix_viewport(MATRIX* o, int left, int top, int width, int height);
MATRIX* matrix_viewportz(MATRIX* o, int left, int top, int width, int height);

/* es쐬܂B
 * [in]
 *	o		ʂi[sB
 *	Lx,Ly,Lz	xNg
 *	Gx,Gy,Gz	eʏ̈_(C)̍W
 *	Nx,Ny,Nz	eʂ̖@xNg
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_shadow(MATRIX* o,
	float Lx, float Ly, float Lz,
	float Gx, float Gy, float Gz,
	float Nx, float Ny, float Nz);

/* xWFȐ(̈ꐬ)vZ܂B
 * [in]
 *	t	pgbNϐ(0.0`1.0)B
 *	Q0	Rg[|Cg#0̍WB
 *	Q1	                    #1
 *	Q2	                    #2
 * [out]
 *	߂l	P(t)̍WlB
 * [note]
 *	* Rg[|Cg->AJ[|CgƌĂԂ̂? (mF)
 */
float bezier1(float t, float Q0, float Q1, float Q2);

/* G~[gȐ(̈ꐬ)vZ܂B
 * [in]
 *	t	pgbNϐ(0.0`1.0)B
 *	Q0	Rg[|Cg#0̍WB
 *	Q1	                    #1
 *	Q0d	Rg[|Cg#0ɂړ_xNgB
 *	Q1d	                    #1
 * [out]
 *	߂l	P(t)̍WlB
 * [note]
 *	* G~[gȐ́Aړ_xNg̑傫ɂĕω܂B
 *	  ܂Aړ_xNg̑傫ɂӖ邽߁A
 *	  ɐړ_xNg𐳋KĂ͂܂B
 *	* ̊֐́AꐬvZ܂B
 *	  Ⴆ΁A3ȐɓKpꍇ́A3gĂB
 *	* f[^ƂăRg[|Cg̍WA
 *	  ړ_xNgȂƂ́Â悤ɂĐĂB
 *		Qnɂړ_xNg = Qn' = a * (Q(n+1) - Q(n-1))
 *		a͔Cӂ̒萔A0.5OオʓI? (mF)
 *	  Ȃ킿AO̓_xNg߁AɈ芄܂B
 *	* W=ԑΏہAړ_xNg=ԑΏۂ̕ω Ƃ݂Ȃ΁A
 *	  ȐȊOɂpł܂B
 */
float hermite1(float t, float Q0, float Q1, float Q0d, float Q1d);

/* _}`̓ɂ邩Oɂ邩𒲂ׂ܂B
 * [in]
 *	px, py		ׂ_̍WB
 *	points		}`̒_XgB
 *	n_points	_̐B
 * [out]
 *	߂l		ȂA0ȊO̒lԂ܂B
 *			OȂA0        Ԃ܂B
 * [note]
 *	* }`́Aʌ^łȂA^ɂΉĂ܂B
 *	* }`̕ӂꍇA̐}`ƌȂ܂B
 *	  XSetFillRules()ɗႦȂ΁AEvenOddRuleɑ܂B
 *	  WindingRuleł̃`FbN@́Â݂Ƃ񋟂Ă܂B
 */
int point_in_polygon(float px, float py, float points[/*n_points*/][2], int n_points);

/* _璼֐낵ʒúAp[^߂܂B
 * [in]
 *	p	_̍WB
 *	a	̎n_WB
 *	da	̃xNgB
 * [out]
 *	߂l	ɐ肽ʒu\Ap[^B
 * [note]
 *	* 𔼒ƌȂꍇAɉ肽肷ɂ:
 *		da𔼒̂̂тւ̃xNgƂs߁A
 *			0 <= s
 *		ȂΔɐB
 *	* ƌȂꍇAɉ肽肷ɂ:
 *		da̎n_I_ւ̃xNgƂs߁A
 *			0 <= s && s < 1
 *		ȂΐɐB
 *	* ۂ̈ʒu q ߂ɂ: q = a + da A
 *		s = point_to_line_s(p, a, da);
 *		vector_mul_1(das, da, s);
 *		vector_add(q, a, das);
 *	* _璼ւ̋߂ɂ: l = |pq| A
 *		vector_sub(pq, q, p);
 *		l = vector_magnitude(pq);
 */
float point_to_line_s(const VECTOR* p, const VECTOR* a, const VECTOR* da);

/* }`̋LqE肩肩𒲂ׂ܂B
 * [in]
 *	points		}`̒_XgB
 *	n_points	_̐B
 * [out]
 *	߂l		EȂ0ȊO̒lԂ܂B
 *			Ȃ0        Ԃ܂B
 * [note]
 *	* ^|SɂΉĂ܂B
 *	* WńAEX+AY+Ƃ܂B
 *	  łȂꍇA߂l͋ẗӖƂȂ܂B
 */
int polygon_orient(float points[/*n_points*/][2], int n_points);

#endif /*__CLIP_MATH_H__*/

