/*	
 *	cliprend.h
 *
 *	Rc`惉Cu`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Feb 13 06:00:00 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_REND_H__
#define __CLIP_REND_H__

/*****************************************************************************
 *	{^`
 *****************************************************************************/

#ifndef PIECE
/* /usr/piece/include/piece_bmp.h */
typedef struct _PBMP_FILEHEADER {
	unsigned long head;		/* + 0,4 VOl`'PBMP' */
	unsigned long fsize;		/* + 4,4 t@CTCY   */
	unsigned char bpp;		/* + 8,1 rbg[x       */
	unsigned char mask;		/* + 9,1 }XN[x       */
	short w;			/* +10,2                */
	short h;			/* +12,2              */
					/* +14,2 pfBO       */
	unsigned long buf_size;		/* +16,4 f[^TCY     */
					/* =20                    */
} PBMP_FILEHEADER;
typedef struct _PIECE_BMP {
	PBMP_FILEHEADER header;		/* + 0,20 wb_       */
	unsigned char* buf;		/* +20, 4 rbgf[^ */
	unsigned char* mask;		/* +24, 4 }XNf[^ */
					/* =28                 */
} PIECE_BMP;
#endif /*PIECE*/
typedef PBMP_FILEHEADER	TEXTUREHEADER;
typedef PIECE_BMP	TEXTURE;

/* T[tFCX\܂B
 */
typedef struct _SURFACE {
	short w;			/* + 0,2              */
	short h;			/* + 2,2            */
	unsigned char* vbuff;		/* + 4,4 J[obt@ */
	unsigned char* zbuff;		/* + 8,4 yobt@     */
					/* =12                  */
} SURFACE;

/* eNX`W\܂B
 */
typedef struct _COORD {
	unsigned char s;		/* +0,1 W */
	unsigned char t;		/* +1,1 W */
					/* =2            */
} COORD;

/* tFCX_\܂B
 */
typedef struct _FACEVERTEX {
	unsigned char iv;		/* +0,1 _WCfNX       */
	unsigned char ic;		/* +1,1 eNX`WCfNX */
} FACEVERTEX;

/* tFCX\܂B
 */
typedef struct _FACE {
	unsigned char nfv;		/* +0,1    _̐              */
	unsigned char c;		/* +1,1    J[                */
	/*FACEVERTEX fv[nfv];*/		/* +2,2nfv tFCX_Xg    */
					/* =2+2nfv                       */
} FACE;

/* bV\܂B
 */
typedef struct _MESH {
	unsigned char nv;		/* +0,1            _W̐         */
	unsigned char nc;		/* +1,1            eNX`W̐   */
	unsigned char nf;		/* +2,1            tFCX̐         */
	unsigned char reserved;		/* +3,1            (\)               */
	/*VECTOR v[nv];*/		/* +4,12nv         _WXg       */
	/*COORD c[nc];*/		/* +4+12nv,2nc     eNX`WXg */
	/*FACE f[nf];*/			/* +4+12nv+2nc,(?) tFCXXg       */
					/* =4+12nv+2nc+(?)                      */
} MESH;

/*****************************************************************************
 *	RENDER
 *****************************************************************************/

#define RENDER_MATRIX_STACK_SIZE	16			/* ϊsX^bNTCY */
#define RENDER_TEXTURE_STACK_SIZE	16			/* eNX`X^bNTCY */

typedef struct _RENDER {
	SURFACE* surface;					/* `T[tFCX         */
	float left, top, right, bottom;				/* r[|[g`         */
	float front, back;					/* NbsO         */
	MATRIX* matrix;						/* ϊsX^bNgbv   */
	TEXTURE** texture;					/* eNX`X^bNgbv */
	MATRIX matrix_stack[RENDER_MATRIX_STACK_SIZE];		/* ϊsX^bN         */
	TEXTURE* texture_stack[RENDER_TEXTURE_STACK_SIZE];	/* eNX`X^bN       */
} RENDER;

/* t[܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	surface		`T[tFCXB
 *	x,y		r[|[g_B
 *	width,height	r[|[gTCYB
 *	front,back	NbsOB
 *	fovy		pxB
 * [note]
 *	* width,height0w肷ƁAT[tFCX̕AƓƌȂ܂B
 *	  ]āAT[tFCXŜr[|[g̈ƂĎw肷ɂ́A
 *	  x,y,width,height0,0,0,0Ǝw肷̂ȒPłB
 *	* ̊֐́AT[tFCX̃NAs܂B
 *	  J[obt@тyobt@̃NÁAĂяoōsĂB
 */
void render_init(RENDER* render, SURFACE* surface, int x, int y, int width, int height, float front, float back, float fovy);

/* ϊsPUSH܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	matrix		ϊsB
 */
void render_push_matrix(RENDER* render, const MATRIX* matrix);

/* ϊsPOP܂B
 * [in]
 *	render		_[ւ̃|C^B
 */
void render_pop_matrix(RENDER* render);

/* eNX`PUSH܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	texture		eNX`B
 */
void render_push_texture(RENDER* render, TEXTURE* texture);

/* eNX`POP܂B
 * [in]
 *	render		_[ւ̃|C^B
 */
void render_pop_texture(RENDER* render);

/* `܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		n_WB
 *	x1,y1		I_WB
 *	color		J[B
 * [note]
 *	* p``߂ɁAAČĂяo邱Ƃz肵Ă܂B
 *	  āAI_sNZ(x1,y1)͕`܂B
 *	* ̓sANbsOꂽ̏I_`Ȃ̂ŁA
 *	  ʓʊOւ̐`ƂƁAʒ[1sNZ
 *	  ԂłĂ܂܂BTODO:vC
 */
void render_line(RENDER* render, int x0, int y0, int x1, int y1, int color);

/* bV`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	mesh		`悳郁bVB
 */
void render_mesh(RENDER* render, const MESH* mesh);

#endif /*__CLIP_REND_H__*/
