/*
 *	demo.c
 *
 *	* Sun Jan 20 18:22:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	demo
 ****************************************************************************/

unsigned char zbuff[DISP_X * DISP_Y];
SURFACE surface = { DISP_X, DISP_Y, vbuff, zbuff };
TEXTURE texture;
RENDER render;
CHR bg = { &bmp2, 0, 0, 128, 88 };
struct {
	MESH m;
	VECTOR v[8];
	COORD c[4];
	struct {
		FACE f;
		FACEVERTEX fv[4];
	} f[6];
} mesh = {
	{
	  8, 4, 6
	},{
	  {-1,-1,-1},{-1,1,-1},{1,1,-1},{1,-1,-1},
	  {-1,-1, 1},{-1,1, 1},{1,1, 1},{1,-1, 1}
	},{
	  {0,79},{0,0},{63,0},{63,79},
	},{
	  { { 4,0 }, { {0,0},{1,1},{2,2},{3,3} } },
	  { { 4,1 }, { {7,0},{6,1},{5,2},{4,3} } },
	  { { 4,2 }, { {4,0},{5,1},{1,2},{0,3} } },
	  { { 4,0 }, { {3,0},{2,1},{6,2},{7,3} } },
	  { { 4,1 }, { {1,0},{5,1},{6,2},{2,3} } },
	  { { 4,2 }, { {3,0},{7,1},{4,2},{0,3} } }
	}
};
int pat[4] = { 0, 64, 0, 128 };


void
demo()
{
	static float d;
	int x, y;
	MATRIX m1, m2;
	TEXTUREHEADER* hdr;

	BSET(state, STATE_DEMO);

	hdr = (TEXTUREHEADER*)BMP2M;
	texture.header = *hdr;
	texture.buf = (unsigned char*)(hdr + 1);
	texture.mask = (unsigned char*)(hdr + 1) + hdr->w * hdr->h / 4;

	for(;;) {
		schedule();
		if(pad & TRG_A) break;

		texture.header.mask = timer & 1;
		mesh.c[0].s = mesh.c[1].s = pat[timer >> 2 & 3];
		mesh.c[2].s = mesh.c[3].s = pat[timer >> 2 & 3] + 63;

		putchr(timer % 128      , 0, &bg, DRW_NOMAL);
		putchr(timer % 128 - 128, 0, &bg, DRW_NOMAL);
		memset(zbuff, -1, sizeof zbuff);
		render_init(&render, &surface, 0, 0, 0, 0, 1, 10, PI_2 * 2 / 8);
		render_push_matrix(&render,
			matrix_lookat(&m1, 0, 0, -5, 0, 0, 0, 0));
		render_push_texture(&render, &texture);

		for(y = -0; y <= 0; y += 2) {
			for(x = -0; x <= 0; x += 2) {
				m1 = MATRIX_I;
				matrix_xform(&m1,
					matrix_roty(&m2, d / 3),
					&m1);
				matrix_xform(&m1,
					matrix_xlate(&m2, x, y, 0),
					&m1);
				matrix_xform(&m1,
					matrix_rotz(&m2, d),
					&m1);
				matrix_xform(&m1,
					matrix_rotx(&m2, d),
					&m1);
				matrix_xform(&m1,
					matrix_scale1(&m2, 0.75),
					&m1);
				render_push_matrix(&render, &m1);
				render_mesh(&render, &mesh.m);
				render_pop_matrix(&render);
			}
		}
		d += PI / 100;
	}

	BCLR(state, STATE_DEMO);
}
